//___________________________________________________________________
//___________________________________________________________________
//  Copyright : 2021 BY HOLTEK SEMICONDUCTOR INC
//  File Name : work_mode_polling.h
// Description: 
//Targer Board: None
//   MCU      : BH67F2265
//   Author   : ming
//   Date     : 20210308
//   Version  : V00
//   History  :
//___________________________________________________________________
//___________________________________________________________________


#ifndef _Work_mode_polling_H_
#define	_Work_mode_polling_H_




void 	fun_work_polling(void);
void 	fun_500ms_polling(void);
void	fun_CAL_REEPROM();
void	goto_halt();
void 	Change_Mode(u8 lu8v_work_mode);	
extern	u8	gu8v_work_mode;
extern	u8	gu8v_halt_time;
extern	volatile	__byte_type	gu8v_time_flag;
extern	u8	gu8v_public_time;
extern	u8	gu8v_public_count1;
extern	u8	gu8v_public_count;
extern	u8	gu8v_err_code;
extern	u8	gu8v_unit_setting_time;
#define	gbv_work_polling	gu8v_time_flag.bits.b0
#define	gbv_250ms			gu8v_time_flag.bits.b1
#define	gbv_250ms_tigger	gu8v_time_flag.bits.b2
#define	gbv_500ms			gu8v_time_flag.bits.b3
#define	gbv_500ms_tigger	gu8v_time_flag.bits.b4
#define	gbv_tb1_flag		gu8v_time_flag.bits.b5
#define	gbv_bat_low			gu8v_time_flag.bits.b6

extern	__byte_type			gu8v_sys_flag;
#define	gbv_User_bit0		gu8v_sys_flag.bits.b0
#define	gbv_User_bit1		gu8v_sys_flag.bits.b1
#define	gbv_uptime			gu8v_sys_flag.bits.b2
#define	gbv_User			gu8v_sys_flag.bits.b3
#define	gbv_heart_DIS			gu8v_sys_flag.bits.b4
#define	gbv_loop_measure			gu8v_sys_flag.bits.b5
#define	gbv_second_pump			gu8v_sys_flag.bits.b6
#define	gbv_pressure_lock	gu8v_sys_flag.bits.b7

extern	__byte_type			gu8v_setting_flag;
#define	gbv_unit			gu8v_setting_flag.bits.b0
#define	gbv_sp				gu8v_setting_flag.bits.b1
#define	gbv_12h_24h			gu8v_setting_flag.bits.b2



//#define	gu8v_user_num		(gu8v_sys_flag.u8&0x03)
extern	u8	gu8v_user_num;
extern	u8	gu8v_heart_count;
extern	u16	gu8v_BAT_ADC;


extern	u16	gu16v_pressure_max;
extern	u16	gu16v_pressure_min;
extern	u8	gu8v_filter_guide;

#define	Sys_Normal_mode			0
#define	Sys_Power_On_mode		1
#define	Sys_Time_Dis_mode		2
#define	Sys_Measure_mode		3
#define	Sys_Find_History_mode	4
#define	Sys_Set_Time_mode		5
#define	Sys_Pressure_Test_mode	6
#define	Sys_Calibration_mode	7
#define	Sys_Comparison_mode		8
#define	Sys_HALT_mode			9
#define	Sys_bpmTEST_mode		10
#define	Sys_bpmsample_mode		11
#define	Sys_T1_mode				12	//up to 300mmhg
#define	Sys_BATERR_mode			13
#define	Sys_Set_user_mode		14


void 	Sys_Normal();
void 	sys_time();
void 	Sys_Power_On();
void 	Sys_Time_Dis();
void 	Sys_Measure();
//void Sys_Measure_test();
void 	Sys_Find_History();
void 	Sys_Set_Time();
void 	Sys_Pressure_Test();
void 	Sys_Calibration_Time();
void	fun_CAL_WEEPROM();
void	fun_cal_pressure(u16 lu16v_pressure);
void	fun_auto_zero_pressure(u16 lu16v_pressure);
void 	Sys_init_heart_wave();
void 	Sys_Comparison();
void 	Sys_HALT();
void 	Change_Mode(u8 lu8v_work_mode);
void 	Sys_lower_power();
void	Sys_BATERR();
void 	Sys_T1();
void	Sys_Set_user();
#endif
